ScriptName = Lil' Builder
RegExMatch("$LastChangedRevision: 11 $"
         . "$LastChangedDate: 2007-06-02 22:26:04 +0200 (Sa, 02 Jun 2007) $"
         , "(?P<Num>\d+).*?(?P<Date>(?:\d+-?){3})", SVN_Rev)

#NoEnv
#SingleInstance force
SetBatchLines, -1
SetControlDelay, -1 
CoordMode, Mouse, Screen 
OnExit, LilBuilder_OnExit
Dic("initialize")

LilBuilder()

; ListVars

Return
;####################  End  of  Auto-Exec  #####################################

;Actions On Exit
LilBuilder_OnExit:
  Dock_ShutDown()
  Control("Remove","All")
  Gui("Remove","All")
  Project("Remove")
  Dic("uninitialize")
  ExitApp
Return

;external modules
#include ext\MMenu\MMenu.ahk
#include ext\Dic\Dic.ahk

;code to include
#include wrapper\IE.ahk              ;wrappers for controls
#Include wrapper\CoHelper.ahk
#include wrapper\Structs.ahk
#include wrapper\Dock.ahk
#include wrapper\HiEdit.ahk
#include wrapper\RaGrid.ahk
#include wrapper\HLink.ahk

;necessary function for HLink control
HLink_Notify(p1, p2, p3){
   msgbox %p1%
}

#include inc\Toolbox.ahk         ;LilBuilder code
#include inc\Gui.ahk
#include inc\Selector.ahk
#include inc\Grid.ahk
#include inc\Messages.ahk
#include inc\Control.ahk
#include inc\Project.ahk
#include inc\Menu.ahk

#include menu\Text.ahk            ;menus for standard controls
#include menu\Edit.ahk
#include menu\ComboBox.ahk
#include menu\Button.ahk
#include menu\CheckBox.ahk
#include menu\Radio.ahk
#include menu\Picture.ahk
#include menu\ListBox.ahk
#include menu\ListView.ahk
#include menu\TreeView.ahk
#include menu\Tab.ahk
#include menu\HotKey.ahk
#include menu\GroupBox.ahk
#include menu\DateTime.ahk
#include menu\MonthCal.ahk
#include menu\Progress.ahk
#include menu\UpDown.ahk
#include menu\Slider.ahk
#include menu\StatusBar.ahk

;###############################################################################
;#######        M  A  I  N       ###############################################
;###############################################################################

;main
LilBuilder(){
  LilBuilder_InitializeValues()          ;initalize some values

  LilBuilder_CreateTrayMenu()            ;create tray menu

  Selector_Create()                      ;create selector gui

  ToolBox_Create()                       ;create toolbox

  Gui_Create()                           ;create an empty gui

  LilBuilder_DockWindows()               ;dock toolbox to empty gui

  Menu_Create()                          ;create Menus

  Messages_SetHandlers( true )           ;enable message handlers

  LilBuilder_InitializeHotkeys()         ;set up hotkeys
}

;###############################################################################
;###############################################################################
;###############################################################################

LilBuilder_InitializeValues(){
  global

}

;###############################################################################

LilBuilder_CreateTrayMenu(){

}

;###############################################################################

LilBuilder_DockWindows(){
  global
  Dock_HostId   := Selector_SelGuiHWND()    ;??? works only for first gui
  Dock_ClientID := Toolbox_HWND()

  Dock(0,-1,-10, 0,0,0, 0,130, 0,665)    ;dock toolbox to left, top

  Dock_Update(Dock_HostId)               ; :D

  DisableSystemMenuCommand(Dock_HostId)     ;disable window movement
  DisableSystemMenuCommand(Dock_ClientID)

}

;###############################################################################

LilBuilder_InitializeHotkeys(){
  Hotkey, IfWinActive, % "ahk_id " Selector_HWND()
  Hotkey, DEL, Selector_OnDelete
  Hotkey, LShift, Grid_Change
  Hotkey, LAlt, Grid_Change
  Hotkey, IfWinActive
}

;###############################################################################

DisableSystemMenuCommand(hWnd = "", SystemCommand = "0xF010") {   ; SC_MOVE = 0xF010
  if !hWnd
    hWnd := WinExist("A")  ; Active window handle
  hSysMenu := DllCall("GetSystemMenu", "Int", hWnd, "Int", False)  ; Retrieve SystemMenu handle
  return DllCall("RemoveMenu", "Int", hSysMenu, "UInt", SystemCommand, "UInt", 0)  ; MF_BYCOMMAND = 0
} 
