;###############################################################################
/* Messages for LilBuilder

*/
;###############################################################################

Messages_SetHandlers( pFlag ) {
  static WM_LBUTTONDOWN   := 0x201
       , WM_LBUTTONUP     := 0x202
       , WM_LBUTTONDBLCLK := 0x203
       , WM_RBUTTONDOWN   := 0x204
       , WM_RBUTTONUP     := 0x205
       , WM_RBUTTONDBLCLK := 0x206
       , WM_MBUTTONDOWN   := 0x207
       , WM_MBUTTONUP     := 0x208
       , WM_MBUTTONDBLCLK := 0x209
       , WM_MOUSEWHEEL    := 0x20A
       , WM_MOUSEMOVE     := 0x200
       , WM_SYSCOMMAND    := 0x112

  OnMessage(WM_LBUTTONDOWN,     "Messages_OnLButtonDown")
  OnMessage(WM_LBUTTONUP,       "Messages_OnLButtonUp")
  OnMessage(WM_LBUTTONDBLCLK,   "Messages_OnLButtonDBLCLK")
  OnMessage(WM_RBUTTONDOWN,     "Messages_OnRButtonDown")
  OnMessage(WM_RBUTTONUP,       "Messages_OnRButtonUp")
  OnMessage(WM_RBUTTONDBLCLK,   "Messages_OnRButtonDBLCLK")
  OnMessage(WM_MBUTTONDOWN,     "Messages_OnMButtonDown")
  OnMessage(WM_MBUTTONUP,       "Messages_OnMButtonUp")
  OnMessage(WM_MBUTTONDBLCLK,   "Messages_OnMButtonDBLCLK")
  OnMessage(WM_MOUSEWHEEL,      "Messages_OnMouseWheel")
  OnMessage(WM_MOUSEMOVE,       "Messages_OnMouseMove")
  OnMessage(WM_SYSCOMMAND,      "Messages_OnSysCommand")
}

Messages_OnLButtonDown(wparam, lparam, msg, hwnd){
   ha := DllCall("GetAncestor", "uint", hwnd, "uint", 2) + 0      ;get gui handle [ GA_ROOT ]
   if Project_IsUserGUI(ha) {
      Selector_SelCtrlHwnd("No")
      Selector_SelGuiHwnd(ha + 0)
      MouseGetPos, ,,, hCtrl, 2
      if hCtrl {
         Selector_SelCtrlHwnd(0 + TopChild(ha, hCtrl))
         Selector_Set2Ctrl()
         return 0
      }
   }
}
TopChild(pParent, h) {
   loop {
      hp := DllCall("GetParent", "uint", h)
      if (hp=pParent) or !hp
         return h
      h := hp
   }
}

Messages_OnLButtonUp(wparam, lparam, msg, hwnd){
     ;??? nothing yet
}

Messages_OnLButtonDBLCLK(wparam, lparam, msg, hwnd){
     ;??? nothing yet
}

Messages_OnRButtonDown(wparam, lparam, msg, hwnd){
  MouseGetPos, X, Y, GuiHWND, CtrlHWND, 2
  Menu_X(X)
  Menu_Y(Y)
  if (hwnd = Selector_HWND()){
    Menu_SelGuiHWND(Selector_SelGuiHwnd())
    Menu_SelCtrlHWND(Selector_SelCtrlHwnd())

    Messages_ShowMenu(Selector_SelCtrlHwnd())
  }
  Else If Project_IsUserGUI(0 + GuiHWND){
    Menu_SelGuiHWND(Selector_SelGuiHwnd())
    If CtrlHWND {
        Menu_SelCtrlHWND(0 + CtrlHWND)
        Messages_ShowMenu(0 + CtrlHWND)
    }
    Else
        GoSub, Gui_ShowMenu
  }
  Else If (hwnd = Toolbox_HWND()){
     ;??? nothing yet
  }
}

Messages_ShowMenu(CtrlHWND){
  local Type, Label            ;??? maybe all can be local
  If !(Type := Control(CtrlHWND, "Type"))
    Return
  Label = %Type%_ShowMenu
  If IsLabel(Label)
      GoSub, %Label%
}

Messages_OnRButtonUp(wparam, lparam, msg, hwnd){
     ;??? nothing yet
}

Messages_OnRButtonDBLCLK(wparam, lparam, msg, hwnd){
     ;??? nothing yet
}

Messages_OnMButtonDown(wparam, lparam, msg, hwnd){
     ;??? nothing yet
}

Messages_OnMButtonUp(wparam, lparam, msg, hwnd){
     ;??? nothing yet
}

Messages_OnMouseWheel(wparam, lparam, msg, hwnd){
     ;??? nothing yet
}

Messages_OnMouseMove(wparam, lparam, msg, hwnd) {
  if (hwnd = Selector_HWND() and GetKeyState("LButton")){
    SendMessage, 0x112,0xF012,0,,% "ahk_id " Selector_HWND() ; [ WM_SYSCOMMAND, SC_MOVE ]
    If GRID()
      Selector_UpdateCtrlwGrid()
    else Selector_UpdateCtrl()
    GoSub, Selector_UpdateItself
  }
}

Messages_OnSysCommand(wparam, lparam, msg, hwnd){
     ;??? nothing yet
}
