RG_SetHdrHeight(hGrd, h){
	global
	SendMessage,GM_SETHDRHEIGHT,0,h,, ahk_id %hGrd%
	return ErrorLevel
}

RG_SetRowHeight(hGrd, h){		
	global
	SendMessage,GM_SETROWHEIGHT,0,h,, ahk_id %hGrd%
	return ErrorLevel
}


RG_AddRow(hGrd, aCol){
	 local RAW

	 VarSetCapacity(RAW, 8, 0)
	 InsertInteger(&aCol1, RAW, 0)       ;??? aCol1 ? should it be aCol
	 InsertInteger(&aCol2, RAW, 4)       ;??? aCol2 ? should it be aCol

	 SendMessage,GM_ADDROW,0,&RAW,, ahk_id %hGrd%
	 return ErrorLevel
}

RG_Sort(hGrd, col, type){
	 global
  	 SendMessage,GM_COLUMNSORT,col,&type,, ahk_id %hGrd%
}


	
RG_AddColumn(hGrd, o1="", o2="", o3="", o4="", o5="", o6=""){
	local j, prop
	local w, cap, ha, ca, type, textmax, hdrflag

	loop, 6 {
		if !o%A_index%
			continue

		j := InStr( o%A_index%, "=" )
		prop := SubStr(	o%A_index%, 1, j-1 )
		%prop% := SubStr( o%A_index%, j+1, 100)
	}
	

	VarSetCapacity(COL, 48, 0)      ;??? is COL local?
	InsertInteger(w, COL, 0)
	InsertInteger(&cap, COL, 4)
	InsertInteger(ha, COL, 8)
	InsertInteger(ca, COL, 12)
	InsertInteger(type, COL, 16)
	InsertInteger(textmax, COL, 20)
	InsertInteger(hdrflag, COL, 24)
	
	SendMessage,GM_ADDCOL,0, &col,, ahk_id %hGrd%
	return ErrorLevel
}

RG_Add(hwnd,x,y,w,h, style){
	local hCtrl
	static	 WS_CLIPCHILDREN := 0x2000000
			,WS_VISIBLE		:= 0x10000000
			,WS_CHILD		:= 0x40000000


   hModule := DllCall("LoadLibrary", "str", "dll\RAGrid.dll")    ;??? is hModule and szAppName local ?
   hCtrl := DllCall("CreateWindowEx"
      , "Uint", 0x200            ; WS_EX_CLIENTEDGE
      , "str",  "RAGrid"         ; ClassName
      , "str",  szAppName      ; WindowName
      , "Uint", WS_CLIPCHILDREN | WS_CHILD | WS_VISIBLE | style
      , "int",  x            ; Left
      , "int",  y            ; Top
      , "int",  w            ; Width
      , "int",  h            ; Height
      , "Uint", hwnd         ; hWndParent
      , "Uint", 0            ; hMenu
      , "Uint", 0            ; hInstance
      , "Uint", 0)


	return hCtrl
}

;--------------------------------------------------------------------------------------------
; B - back color
; G - grid color
; T - text color
RG_SetColors(hGrd, colors){
	local c, token, B, G, T
	static HEM_SETCOLORS := 2036


	Loop, Parse, colors, %A_Space%
	{
		if A_LoopField =
			continue

		StringLeft c, A_LoopField, 1
		StringTrimLeft token, A_LoopField, 1
		
		%c% := "0x" token
	}


	if (B)
		SendMessage,GM_SETBACKCOLOR,B,0,, ahk_id %hGrd%
	
	if (G)
 		SendMessage,GM_SETGRIDCOLOR,G,0,, ahk_id %hGrd%

	if (T)
		SendMessage,GM_SETTEXTCOLOR,T,0,, ahk_id %hGrd%
	
}

RG_SetFont(hGrd, pFont="") { 
   local height, weight, italic, underline, strikeout , nCharSet 
   local hFont, fontFace, LogPixels
   static WM_SETFONT := 0x30


 ;parse font 
   italic      := InStr(pFont, "italic")    ?  1    :  0 
   underline   := InStr(pFont, "underline") ?  1    :  0 
   strikeout   := InStr(pFont, "strikeout") ?  1    :  0 
   weight      := InStr(pFont, "bold")      ? 700   : 400 

 ;height 
   RegExMatch(pFont, "(?<=[S|s])(\d{1,2})(?=[ ,])", height) 
   if (height = "") 
      height := 10 
   RegRead, LogPixels, HKEY_LOCAL_MACHINE, SOFTWARE\Microsoft\Windows NT\CurrentVersion\FontDPI, LogPixels 
   height := -DllCall("MulDiv", "int", Height, "int", LogPixels, "int", 72) 

 ;face 
   RegExMatch(pFont, "(?<=,).+", fontFace)    
   if (fontFace != "") 
       fontFace := RegExReplace( fontFace, "(^\s*)|(\s*$)")      ;trim 
   else fontFace := "MS Sans Serif" 

 ;create font 
   hFont   := DllCall("CreateFont", "int",  height, "int",  0, "int",  0, "int", 0 
                      ,"int",  weight,   "Uint", italic,   "Uint", underline 
                      ,"uint", strikeOut, "Uint", nCharSet, "Uint", 0, "Uint", 0, "Uint", 0, "Uint", 0, "str", fontFace) 

   SendMessage,WM_SETFONT,hFont,TRUE,,ahk_id %hGrd%
   return ErrorLevel
}

RG_Init(){
	global
	static init := false
	
	if (init)
		return
	init := true

	STYLE_NOSEL			:= 0x01
	STYLE_NOFOCUS		:= 0x02
	STYLE_GRIDLINES		:= 0x04
	STYLE_VGRIDLINES	:= 0x08
	STYLE_GRIDFRAME		:= 0x10
	STYLE_NOCOLSIZE		:= 0x20


	GM_ADDCOL			 := 0x400+1		;wParam=0, lParam=lpCOLUMN
	GM_ADDROW			 := 0x400+2		;wParam=0, lParam=lpROWDATA (can be NULL)
	GM_INSROW			 := 0x400+3		;wParam=nRow, lParam=lpROWDATA (can be NULL)
	GM_DELROW			 := 0x400+4		;wParam=nRow, lParam=0
	GM_MOVEROW			 := 0x400+5		;wParam=nFromRow, lParam=nToRow
	GM_COMBOADDSTRING	 := 0x400+6		;wParam=nCol, lParam=lpszString
	GM_COMBOCLEAR		 := 0x400+7		;wParam=nCol, lParam=0
	GM_GETCURSEL		 := 0x400+8		;wParam=0, lParam=0
	GM_SETCURSEL		 := 0x400+9		;wParam=nCol, lParam=nRow
	GM_GETCURCOL		 := 0x400+10	;wParam=0, lParam=0
	GM_SETCURCOL		 := 0x400+11	;wParam=nCol, lParam=0
	GM_GETCURROW		 := 0x400+12	;wParam=0, lParam=0
	GM_SETCURROW		 := 0x400+13	;wParam=nRow, lParam=0
	GM_GETCOLCOUNT		 := 0x400+14	;wParam=0, lParam=0
	GM_GETROWCOUNT		 := 0x400+15	;wParam=0, lParam=0
	GM_GETCELLDATA		 := 0x400+16	;wParam=nRowCol, lParam=lpData
	GM_SETCELLDATA		 := 0x400+17	;wParam=nRowCol, lParam=lpData (can be NULL)
	GM_GETCELLRECT		 := 0x400+18	;wParam=nRowCol, lParam=lpRECT
	GM_SCROLLCELL		 := 0x400+19	;wParam=0, lParam=0
	GM_GETBACKCOLOR		 := 0x400+20	;wParam=0, lParam=0
	GM_SETBACKCOLOR		 := 0x400+21	;wParam=nColor, lParam=0
	GM_GETGRIDCOLOR		 := 0x400+22	;wParam=0, lParam=0
	GM_SETGRIDCOLOR		 := 0x400+23	;wParam=nColor, lParam=0
	GM_GETTEXTCOLOR		 := 0x400+24	;wParam=0, lParam=0
	GM_SETTEXTCOLOR		 := 0x400+25	;wParam=nColor, lParam=0
	GM_ENTEREDIT		 := 0x400+26	;wParam=nCol, lParam=nRow
	GM_ENDEDIT			 := 0x400+27	;wParam=nRowCol, lParam=fCancel
	GM_GETCOLWIDTH		 := 0x400+28	;wParam=nCol, lParam=0
	GM_SETCOLWIDTH		 := 0x400+29	;wParam=nCol, lParam=nWidth
	GM_GETHDRHEIGHT		 := 0x400+30	;wParam=0, lParam=0
	GM_SETHDRHEIGHT		 := 0x400+31	;wParam=0, lParam=nHeight
	GM_GETROWHEIGHT		 := 0x400+32	;wParam=0, lParam=0
	GM_SETROWHEIGHT		 := 0x400+33	;wParam=0, lParam=nHeight
	GM_RESETCONTENT		 := 0x400+34	;wParam=0, lParam=0
	GM_COLUMNSORT		 := 0x400+35	;wParam=nCol, lParam=0=Ascending, 1=Descending, 2=Invert
	GM_GETHDRTEXT		 := 0x400+36	;wParam=nCol, lParam=lpBuffer
	GM_SETHDRTEXT		 := 0x400+37	;wParam=nCol, lParam=lpszText
	GM_GETCOLFORMAT		 := 0x400+38	;wParam=nCol, lParam=lpBuffer
	GM_SETCOLFORMAT		 := 0x400+39	;wParam=nCol, lParam=lpszText
	GM_CELLCONVERT		 := 0x400+40	;wParam=nRowCol, lParam=lpBuffer
	GM_RESETCOLUMNS		 := 0x400+41	;wParam=0, lParam=0
	GM_GETROWCOLOR		 := 0x400+42	;wParam=nRow, lParam=lpROWCOLOR
	GM_SETROWCOLOR		 := 0x400+43	;wParam=nRow, lParam=lpROWCOLOR
	GM_GETCOLDATA		 := 0x400+44	;wParam=nCol, lParam=lpCOLUMN

	;Column alignment
	GA_ALIGN_LEFT		 := 0
	GA_ALIGN_CENTER		 := 1
	GA_ALIGN_RIGHT		 := 2

	;Column types
	TYPE_EDITTEXT		 := 0			;String
	TYPE_EDITLONG		 := 1			;Long
	TYPE_CHECKBOX		 := 2			;Long
	TYPE_COMBOBOX		 := 3			;Long
	TYPE_HOTKEY			 := 4			;Long
	TYPE_BUTTON			 := 5			;String
	TYPE_IMAGE			 := 6			;Long
	TYPE_DATE			 := 7			;Long
	TYPE_TIME			 := 8			;Long
	TYPE_USER			 := 9			;0=String, 1 to 512 bytes binary data
	TYPE_EDITBUTTON		 := 10			;String

	;Column sorting
	SORT_ASCENDING		 := 0
	SORT_DESCENDING		 := 1
	SORT_INVERT			 := 2

	return true
}
